= Project Management =
[[TOC(heading=About SecureCI™,depth=2,AboutSecureCI/*)]]

== Trac ==

A key property for successful communication within a project is being able to find the information team members require. 
Using a wiki is a convenient way to allow the team to gather and organize project information with a minimum of 
overhead, as well as minimal reliance on outside parties. Anyone can be granted permission to add or modify information 
to the wiki.

SecureCI™ uses [http://trac.edgewall.org/ Trac] to provide a wiki. Trac also provides a customizable 
[/report bug/issue tracking system], project planning via milestones and the [/roadmap roadmap], a 
[/browser source code repository browser], and [/search search] capabilities across the whole site.

 * [/ Trac Wiki front page]
 * [AboutWiki Trac documentation]
 * [HowTo/AddNewLoginUser How do I add a new user?]

Trac tickets are integrated with the Subversion repository commits via the [HowTo/TracPostCommitHook trac-post-commit-hook].

<% if ::File.directory?("#{node['agilo']['home']}") %>
== Agilo ==

The usage model of Agilo for trac is based on the Scrum framework for software development by Ken Schwaber, 
Jeff Sutherland and Mike Beedle. In order to use Agilo for Scrum in the way it is intended, please make sure 
you understand the Scrum framework and know the featured artifacts, ceremonies and roles. You might find also 
some aspects which are not defined or used in the theoretical Scrum approach. These are based on practical 
experiences and have proven to be effective and useful. 

In Agilo you can not only create different items, like Requirements, User Stories or Tasks, but you can also 
create links between them. These links are bidirectional. This unique functionality of Agilo for trac helps you 
for example to analyze the impact of a change or a bug, or to estimate new versions of a product.

For more information, checkout Agilo's [http://www.agilofortrac.com/documentation/ documentation] and [http://www.agilofortrac.com/faq-agilo-trac/ FAQs]

<% end %>
<% if ::File.directory?("#{node['sonar']['home']}") %>
== Sonar ==

[http://sonar.codehaus.org/ Sonar] is a Maven plugin that can run [../Testing#Cobertura Cobertura], 
[../CodeAnalysis#Checkstyle Checkstyle], [../CodeAnalysis#PMD PMD], [../CodeAnalysis#FindBugs FindBugs], and some other 
tools to gather metrics. Its strength is in providing a dashboard, trending reports, and drilldowns to help visualize 
the state of a software project's code quality.

 * [//sonar/ Sonar code quality dashboard]
 * [HowTo/UseSonar How do I use Sonar to see code quality in my project?]

An optional [http://docs.codehaus.org/display/SONAR/Technical+Debt+Plugin Technical Debt plugin] was added. This plugin 
adds a metric that rolls up the other metrics into a very rough estimate of cost (in man days and dollars) to bring all 
the quality indicators to their maximum value (e.g., no duplicate code, no violations, 100% code coverage, etc.). It may 
be more useful to note the trend of the technical debt over time than the absolute value.

Another optional [http://docs.codehaus.org/display/SONAR/Security+Rules+Plugin Security Rules plugin] was also added.
This module reports on rules that are specifically and directly related to security.

A custom ratproxy plugin was also installed. This plugin reads a ratproxy log file and tracks the count of high, medium, 
and low risk findings. The counts are available on the dashboard and in the Time machine for monitoring the trends.
A project could use a combination of [../Testing#Selenium Selenium] and [../SecurityScanning#ratproxy ratproxy] to
incorporate security scanning into the continuous integration process, using Sonar to visualize the findings. 

<% end %>
<% if ::File.directory?("#{node['gitblit']['home']}") %>
== !GitBlit ==

[http://gitblit.com/ GitBlit] is an open-source, pure Java stack for managing, viewing, and serving Git repositories.
It's designed primarily as a tool for small workgroups who want to host centralized repositories.

 * [/gitblit/ GitBlit]
 * [/gitblit/repositories/ Repository]
 * [/admin/accounts/users Manage User Accounts]
 * [HowTo/UseGitBlit How do I manage my repositories with GitBlit?]
 * [HowTo/UseGit How do I use an existing/remote Git repository?]
 
!GitBlit is installed as an standalone service, called Gitblit GO. It is an integrated, single-stack solution based on Jetty.
!GitBlit is integrated into SecureCI™, with access being allowed via htpasswd, similar to Trac and Subversion.

<% end %>
=== Installation details ===

Trac was installed via the Python easy_install module. Trac is installed in `<%= node['trac']['basedir'] %>`, with this Trac project at 
`<%= node['trac']['projectdir'] %>`. Content is stored in the `trac` database in [../Support#Database MySQL].

Web access is provided by the [../Support#WebServer Apache HTTP Server], using HTTP Basic Authentication (htpasswd file 
`<%= node['subversion']['auth_user_file'] %>`) and file-level access controlled by the dav_svn module (file 
`<%= node['subversion']['auth_access_file'] %>`). Trac shares the authentication and authorization files with 
[../Development#Subversion Subversion], and can be used to administer authentication and authorization using the 
[http://trac-hacks.org/wiki/AccountManagerPlugin AccountManagerPlugin] and the 
[http://trac-hacks.org/wiki/SvnAuthzAdminPlugin SvnAuthzAdminPlugin]. 

Trac also provides an interface for configuring pre and post hooks in Subversion using the 
[http://trac-hacks.org/wiki/TracSvnPoliciesPlugin TracSvnPoliciesPlugin]. 
WYSIWYG-editing capability is provided by the [http://trac-hacks.org/wiki/TracWysiwygPlugin TracWysiwygPlugin].
Table of contents on wiki pages is provided by the [http://trac-hacks.org/wiki/TocMacro TocMacro].
Configuration (`trac.ini`) editing is provided by the [http://trac-hacks.org/wiki/IniAdminPlugin IniAdminPlugin]. 
Navigation customization is provided by the [http://trac-hacks.org/wiki/NavAddPlugin NavAddPlugin]. 
A link to the Subversion repository URL in the repository browser is provided by the 
[http://trac-hacks.org/wiki/SubversionLocationPlugin SubversionLocationPlugin].

<% if ::File.directory?("#{node['sonar']['home']}") %>
Sonar is installed as a standalone application in `<%= node['sonar']['home'] %>`, with log files being written to `<%= node['sonar']['home'] %>/logs`. Sonar runs as a server, 
proxied by [../Support#WebServer Apache HTTP] via the AJP connector on port 9009 and uses the `sonar` database in 
[../Support#Database MySQL].

<% end %>
<% if ::File.directory?("#{node['ratproxy']['base_dir']}") %>
The source code for the ratproxy plugin for Sonar is in `<%= node['ratproxy']['base_dir'] %>`.
 
<% end %>
<%= node['trac']['wiki']['footer'] %>